lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Message-ID: <592a32d6-b618-951c-9db9-711d022ff85e@arm.com>
Date:   Wed, 16 Mar 2022 17:30:02 +0000
From:   James Clark <james.clark@....com>
To:     German Gomez <german.gomez@....com>, linux-kernel@...r.kernel.org,
        linux-perf-users@...r.kernel.org, acme@...nel.org
Cc:     mark.rutland@....com, namhyung@...nel.org, leo.yan@...aro.org,
        Alexandre.Truong@....com, Jiri Olsa <jolsa@...nel.org>
Subject: Re: [PATCH v2 1/1] perf test arm64: Test unwinding using fame-pointer
 (fp) mode



On 16/03/2022 17:20, German Gomez wrote:
> Add a shell script to check that the call-graphs generated using frame
> pointers (--call-graph fp) are complete and not missing leaf functions:
> 
>   | $ perf test 88 -v
>   |  88: Check Arm64 callgraphs are complete in fp mode                  :
>   | --- start ---
>   | test child forked, pid 8734
>   |  + Compiling test program (/tmp/test_program.Cz3yL)...
>   |  + Recording (PID=8749)...
>   |  + Stopping perf-record...
>   | test_program.Cz
>   |                  728 leaf
>   |                  753 parent
>   |                  76c main
>   | test child finished with 0
>   | ---- end ----
>   | Check Arm SPE callgraphs are complete in fp mode: Ok
> 

Ran it on N1SDP and it passes, and it fails if b9f6fbb3b2c2 isn't applied.

Reviewed-by: James Clark <james.clark@....com>

> Fixes: b9f6fbb3b2c2 ("perf arm64: Inject missing frames when using 'perf record --call-graph=fp'")
> Suggested-by: Jiri Olsa <jolsa@...nel.org>
> Signed-off-by: German Gomez <german.gomez@....com>
> ---
> Changes since v1: https://lore.kernel.org/all/a6ba0ea8-f070-9f79-f018-f638ff677c7c@arm.com/
>  - Add explicit '-g' flag to GCC command
> ---
>  .../perf/tests/shell/test_arm_callgraph_fp.sh | 68 +++++++++++++++++++
>  1 file changed, 68 insertions(+)
>  create mode 100755 tools/perf/tests/shell/test_arm_callgraph_fp.sh
> 
> diff --git a/tools/perf/tests/shell/test_arm_callgraph_fp.sh b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> new file mode 100755
> index 000000000..ea1b4e6bb
> --- /dev/null
> +++ b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> @@ -0,0 +1,68 @@
> +#!/bin/sh
> +# Check Arm64 callgraphs are complete in fp mode
> +# SPDX-License-Identifier: GPL-2.0
> +
> +lscpu | grep -q "aarch64" || exit 2
> +
> +if ! [ -x "$(command -v cc)" ]; then
> +	echo "failed: no compiler, install gcc"
> +	exit 2
> +fi
> +
> +PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
> +TEST_PROGRAM_SOURCE=$(mktemp /tmp/test_program.XXXXX.c)
> +TEST_PROGRAM=$(mktemp /tmp/test_program.XXXXX)
> +
> +cleanup_files()
> +{
> +	rm -f $PERF_DATA
> +	rm -f $TEST_PROGRAM_SOURCE
> +	rm -f $TEST_PROGRAM
> +}
> +
> +trap cleanup_files exit term int
> +
> +cat << EOF > $TEST_PROGRAM_SOURCE
> +int a = 0;
> +void leaf(void) {
> +  for (;;)
> +    a += a;
> +}
> +void parent(void) {
> +  leaf();
> +}
> +int main(void) {
> +  parent();
> +  return 0;
> +}
> +EOF
> +
> +echo " + Compiling test program ($TEST_PROGRAM)..."
> +
> +CFLAGS="-g -O0 -fno-inline -fno-omit-frame-pointer"
> +cc $CFLAGS $TEST_PROGRAM_SOURCE -o $TEST_PROGRAM || exit 1
> +
> +# Add a 1 second delay to skip samples that are not in the leaf() function
> +perf record -o $PERF_DATA --call-graph fp -e cycles//u -D 1000 -- $TEST_PROGRAM 2> /dev/null &
> +PID=$!
> +
> +echo " + Recording (PID=$PID)..."
> +sleep 2
> +echo " + Stopping perf-record..."
> +
> +kill $PID
> +wait $PID
> +
> +# expected perf-script output:
> +#
> +# program 
> +# 	728 leaf
> +# 	753 parent
> +# 	76c main
> +# ...
> +
> +perf script -i $PERF_DATA -F comm,ip,sym | head -n4
> +perf script -i $PERF_DATA -F comm,ip,sym | head -n4 | \
> +	awk '{ if ($2 != "") sym[i++] = $2 } END { if (sym[0] != "leaf" ||
> +						       sym[1] != "parent" ||
> +						       sym[2] != "main") exit 1 }'

Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ